#! perl -w
use POSIX;
use Tk;

$top = new MainWindow;
$c = $top->Canvas->pack;

sub display {
  my ($text) = @_;

  # Cration du fichier GIF
  my $tmp = '/tmp/lqkhfdlkqsfd';
  my $pwd = `pwd`;
  chomp($pwd);
  unless( chdir('/tmp') ){ info("cannot chdir to /tmp: $!"); return; }
  unless( open(F, ">$tmp.tex") ){ info("cannot open $tmp.tex: $!"); return; }
  select F;
  print '\documentclass{minimal}\usepackage{amsmath,amsfonts}\pagestyle{empty}\begin{document}$$';
  print $text;
  print '$$\end{document}';
  close(F);
  print STDERR "** LaTeX\n";
  system 'latex', "$tmp.tex" ;
  print STDERR "** dvips\n";
  system "dvips -f -E $tmp.dvi > $tmp.ps";
#  print STDERR "** pstogif\n";
#  system "pstogif $tmp.ps";

  my ($bbx,$bby,$bbw,$bbh);
  open(PS,"$tmp.ps");
  while (<PS>) {
    if (/^%%BoundingBox:\s+(-?\d+)\s+(-?\d+)\s+(-?\d+)\s+(-?\d+)/) {
      $bbx = 0-$1;    $bby = 0-$2;
      $bbw = $3+$bbx;    $bbh = $4+$bby;
      last if /^%%EndComments/;
    }
  }
  close(PS);

  open(GS, "|gs -q -dNOPAUSE -dNO_PAUSE -sDEVICE=ppmraw -g${bbw}x${bbh} -r72 -sOutputFile=$tmp.ppm");
  print GS "$bbx $bby translate\n";
  print GS "($tmp.ps) run\n";
  print GS "showpage\n";
  print GS "quit\n";
  close(GS);

  unless( chdir($pwd) ){ info("cannot chdir back to $pwd: $!); return; }

  $img = $top->Photo(-file => "$tmp.gif");
  $c->createImage(100,100,-image => $img);
}

display('\tan x = \frac{\sin x}{\cos x}');

MainLoop;