sub draw_grid {
  for(my $i=0; $i<30; $i++){
    $w_canvas->createLine($i * $g_grid_x, 0, $i * $g_grid_x, 1000,
			 -fill => 'white', 
			 -tags => 'grid');
    $w_canvas->createLine(0, $i * $g_grid_y, 1000, $i * $g_grid_y, 
			 -fill => 'white', 
			 -tags => 'grid');
  }
}

sub draw_arrow_tmp {
  my ($a,$b,$c,$d) = @_;
  $w_canvas->createLine($a * $g_grid_x, $b * $g_grid_y, 
                        $c * $g_grid_x, $d * $g_grid_y,
                        -arrow => 'last', -width => 3, -fill => 'red',
                        -tags => 'tmp');
}

sub draw_arrow {
  my $id = shift;
  my ($a,$b,$c,$d) = @_;
  $w_canvas->createLine($a * $g_grid_x, $b * $g_grid_y, 
                        $c * $g_grid_x, $d * $g_grid_y,
                        -arrow => 'last', -width => 3, -fill => 'black',
			-tags => ['item', "id:$id"],
                       );
}

sub draw_line_tmp {
  my ($a,$b,$c,$d) = @_;
  $w_canvas->createLine($a * $g_grid_x, $b * $g_grid_y, 
                        $c * $g_grid_x, $d * $g_grid_y,
                        -width => 2, -fill => 'red',
                        -tags => 'tmp');
}

sub draw_line {
  my $id = shift;
  my ($a,$b,$c,$d) = @_;
  $w_canvas->createLine($a * $g_grid_x, $b * $g_grid_y, 
                        $c * $g_grid_x, $d * $g_grid_y,
                        -width => 2, -fill => 'black',
			-tags => ['item', "id:$id"],
                       );
}

sub draw_double_line_tmp {
  my ($a,$b,$c,$d) = @_;
  $w_canvas->createLine($a * $g_grid_x, $b * $g_grid_y, 
                        $c * $g_grid_x, $d * $g_grid_y,
                        -width => 2, -fill => 'red',
                        -tags => 'tmp');
}

sub draw_double_line {
  my $id = shift;
  my ($a,$b,$c,$d) = @_;
  $w_canvas->createLine($a * $g_grid_x, $b * $g_grid_y, 
                        $c * $g_grid_x, $d * $g_grid_y,
                        -width => 8, -fill => 'black',
			-tags => ['item', "id:$id"],
                       );
  $w_canvas->createLine($a * $g_grid_x, $b * $g_grid_y, 
                        $c * $g_grid_x, $d * $g_grid_y,
                        -width => 4, 
			-fill => $w_top->Palette->{background},
			-tags => ['item', "id:$id"],
                       );
}

sub draw_text_old {
  my $id = shift;
  my ($x,$y,$text,$anchor) = @_;
  $w_canvas->createText($x * $g_grid_x, $y * $g_grid_y, 
                        -text => $text, 
			-anchor => $anchor,
			-tags => ['item', "id:$id"],
                       );
}

sub draw_text {
  my $id = shift;
  my ($x,$y,$text,$anchor) = @_;

  # Cration du fichier GIF
  $w_canvas->configure(-cursor => 'watch');
  my $tmp = '/tmp/lqkhfdlkqsfd';
  my $pwd = `pwd`;
  chomp($pwd);
  unless( chdir('/tmp') ){ info("cannot chdir to /tmp: $!"); return; }
  unlink "$tmp.gif";
  unlink "$tmp.dvi";
  unlink "$tmp.ps";
  unlink "$tmp.ppm";
  unlink "$tmp". "001.ppm";
  unlink "$tmp.pbm";
  unless( open(F, ">$tmp.tex") ){ info("cannot open $tmp.tex: $!"); return; }
  select F;
  print $g_latex_preamble;
  print $text;
  print $g_latex_postamble;
  close(F);
  print STDERR "** LaTeX\n";
  system 'latex',  '\nonstopmode\input{'."$tmp.tex".'}' ;
  print STDERR "** dvips\n";
  system "dvips -f -E $tmp.dvi > $tmp.ps";

  my ($bbx,$bby,$bbw,$bbh);
  open(PS,"$tmp.ps");
  while (<PS>) {
    if (/^%%BoundingBox:\s+(-?\d+)\s+(-?\d+)\s+(-?\d+)\s+(-?\d+)/) {
      $bbx = 0-$1;    $bby = 0-$2;
      $bbw = $3+$bbx;    $bbh = $4+$bby;
      last if /^%%EndComments/;
    }
  }
  close(PS);

  my $scale = 3;
  my $density = 72*$scale;
  $bbw = $scale * $bbw;
  $bbh = $scale * $bbh;
  open(GS, "|gs -q -dNOPAUSE -dNO_PAUSE -sDEVICE=ppmraw -g${bbw}x${bbh} -r$density -sOutputFile=$tmp.ppm");
  print GS "$bbx $bby translate\n";
  print GS "($tmp.ps) run\n";
  print GS "showpage\n";
  print GS "quit\n";
  close(GS);

  system("pnmcrop $tmp.ppm | ppmquant 256 | ppmtopgm | pgmtopbm | pbmtoxbm > $tmp.xbm");

  unless( chdir($pwd) ){ info("cannot chdir back to $pwd: $!"); return; }

  $w_canvas->configure(-cursor => 'top_left_arrow');

#  my $img = $w_top->Photo(-file => "$tmp.gif");
  my $img = $w_top->Bitmap(-file => "$tmp.xbm", 
                           -background => $w_top->Palette->{background},
                           );
  my $i = $w_canvas->createImage($x * $g_grid_x, $y * $g_grid_y,
                                 -image => $img,
			         -anchor => $anchor,
                                 -tags => ['item', "id:$id"],
                                );
#  $w_canvas->lower($i);
}