my $w_top = new MainWindow;
$w_top->configure(-title => "Tableau de variation");

# Menu bar

sub menu_entry_set {
  my ($menu, $title, $function) = @_;
  $menu->command(-label => $title, -command => $function);
}

my $w_menubar = $w_top->Frame(-relief => 'raised', -borderwidth => 2)
                      ->pack(-fill => 'x');
my $w_file = $w_menubar->Menubutton(-text => "File", -underline => 0);
  menu_entry_set($w_file, "Load", \&file_load);
  menu_entry_set($w_file, "New",  \&file_new);
  menu_entry_set($w_file, "Save", \&file_save);
  menu_entry_set($w_file, "Save as", \&file_save_as);
  menu_entry_set($w_file, "Quit", \&file_quit);
$w_file->pack(-side=>'left');

my $w_help = $w_menubar->Menubutton(-text => "Help", -underline => 0);
  menu_entry_set($w_help, "About", \&help_about);
$w_help->pack(-side=>'right');

# Buttons and canvas

my $w_center = $w_top->Frame;

my $w_tools = $w_center->Frame->grid;
$w_tools->Button(-text => "Centered text",
                 -command => \&mode_text_center,
                 -width => 20)
		 ->grid(-column => 0, -row => 0);
$w_tools->Button(-text => "Left text",
                 -command => \&mode_text_left,
                 -width => 20)
		 ->grid(-column => 0, -row => 1);
$w_tools->Button(-text => "Right text",
                 -command => \&mode_text_right,
                 -width => 20)
		 ->grid(-column => 0, -row => 2);
$w_tools->Button(-text => "Arrow",
                 -command => \&mode_arrow,
                 -width => 20)
		 ->grid(-column => 0, -row => 3);
$w_tools->Button(-text => "Line",
                 -command => \&mode_line,
                 -width => 20)
		 ->grid(-column => 0, -row => 4);
$w_tools->Button(-text => "Double line",
                 -command => \&mode_double_line,
                 -width => 20)
		 ->grid(-column => 0, -row => 5);
$w_tools->Button(-text => "Add column",
                 -command => \&mode_add_column,
                 -width => 20)
		 ->grid(-column => 0, -row => 6);
$w_tools->Button(-text => "Add row",
                 -command => \&mode_add_line,
                 -width => 20)
		 ->grid(-column => 0, -row => 7);
$w_tools->Button(-text => "Delete",
                 -command => \&mode_delete,
                 -width => 20)
		 ->grid(-column => 0, -row => 8);
#$w_tools->Button(-text => "",
#                 -command => "",
#                 -width => 20)
#		 ->grid(-column => 0, -row => 6);

$w_tools->pack(-side => 'left');

my $w_canvas = $w_center->Canvas(-relief=>'raised', 
                                 -borderwidth => 2,
                                 -width => 800, -height => 600, 
                                 -closeenough => 10);
$w_canvas->pack;

$w_center->pack;

# Mode and mouse explainer

my $w_bottom = $w_top->Frame;

$w_bottom->Label(-text => "Mode: ")->pack(-side => 'left');
my $w_mode = $w_bottom->Label(-text => "none")->pack(-side => 'left');

my $w_mouse_right  = $w_bottom->Label(-text => "", -width => 14, -relief => 'sunken')
                              ->pack(-side => 'right');
my $w_mouse_middle = $w_bottom->Label(-text => "", -width => 17, -relief => 'sunken')
                              ->pack(-side => 'right');
my $w_mouse_left   = $w_bottom->Label(-text => "", -width => 17, -relief => 'sunken')
                              ->pack(-side => 'right');
$w_bottom->Label(-text => "Mouse: ")->pack(-side => 'right');

$w_bottom->pack(-fill => 'x');

sub set_mouse_explainer {
  my ($left, $middle, $right) = @_;
  $w_mouse_left->configure(-text => $left);
  $w_mouse_middle->configure(-text => $middle);
  $w_mouse_right->configure(-text => $right);
}
sub set_mode_name {
  my ($mode) = @_;
  $w_mode->configure(-text => $mode);
}